/*
gui-js/menu.js
created mar. août 30 02:24:47 CEST 2011 by whygee@f-cpu.org
version lun. sept 12 08:17:07 CEST 2011 init_obj() added

This file implements a menu bar that can be independent from ygwm.
  some features depend on winman and avoid closure.
*/

menu={
  list:{},

  unfold_menuItem: function(){
    if (ygwm && (ygwm.moved_div != null))
      return; // No display if ygwm is currently moving a window
    if (this.listlength > 0)
      this.menuItemList.style.display=""; // display only if something to show
  },

  fold_menuItem: function(){
    this.menuItemList.style.display="none";
  },

  onClick: function(){
    winman.activate_window(this.key);
  },

  subMenuItem: function(n,name,func){
    if (n.list[name])
      return n.list[name]; // don't create duplicates
    var o=document.createElement("DIV");
    o.className="menuItem";
    o.innerHTML=name;
    if (typeof func === 'function')
      o.onclick=func;
    else {
      if (typeof func === 'string') {
        o.onclick=menu.onClick;
        o.key=func; // avoid closure
      }
    }
    n.list[name]=o;
    n.listlength++;
    n.menuItemList.appendChild(o);
    return o;
  },

  mainMenuItem: function(name,dir){
    if (menu.list[name])
      return menu.list[name];

    var n=document.createElement("DIV");
    if (dir != "R")
      dir="L"; // class "L" by default (left-justified unless told otherwise)
    n.className="menuBarItem"+dir;

    n.innerHTML="<span>"+name+"</span>";
    n.list={};
    n.listlength=0;
    n.onmouseout =menu.fold_menuItem;
    n.onmouseover=menu.unfold_menuItem;
    menu.list[name]=n;
    menu.mainMenu_id.appendChild(n);
    n.style.width=n.scrollWidth+'px'; // sets the size once and for all

    // create the folding list
    n.menuItemList=document.createElement("DIV");
    n.menuItemList.className="menuItemList";
    n.menuItemList.style.display="none";
    n.appendChild(n.menuItemList);

    return n;
  },

  // the argument list is used to make a first layout
  // to organise the menu, before individual items are created, out of order.
  create: function(){
    if (document.getElementById("MainMenuBar"))
      return alert("menus already created");

    var t, dir="L";
    menu.mainMenu_id=document.createElement("DIV");
    menu.mainMenu_id.id="MainMenuBar";
    document.body.appendChild(menu.mainMenu_id);

    for (var i=0; i < arguments.length; i++) {
      t=arguments[i];
      if (typeof t == "string") {
        if (t=="") // separator
          dir="R";
        else
          menu.mainMenuItem(arguments[i],dir);
      }
    }
  },

  init_obj: function(){
    menu.create("Tools", "Doc",  ""/*separation*/,
      "windows", "LNG"); // reverse order for the elements on the right side
    var u=menu.mainMenuItem("windows","R");
    menu.subMenuItem(u,"Hide&nbsp;all",winlist.minimizeAll);
    menu.subMenuItem(u,"Show&nbsp;all",winlist.restoreAll);
    menu.subMenuItem(u,"Rainbow!", function() {  /* create a "rainbow" */
      for (var i in YGCSS.ColorStyles) {
        setTimeout('ygwm.new_window("'+i+'", null, "none", 160,90,'+rainbow_x+',Math.ceil(('+rainbow_x+'/2)+60), false, true, true, true, false, "'+i+'");',rainbow_x);
        rainbow_x+=40;
      }
    });
  }
}
