/*
gui-js/ygwm-colors.js
created jeu. sept.  8 07:07:48 CEST 2011 by whygee@f-cpu.org
init: taking the CSS routines out of ygwm
version : sam. sept. 10 20:48:42 CEST 2011 : new object name, new color rotation routine
*/

YGCSS={
  insertCssRule: function(rule){
    if (!YGCSS.StyleSheets){
      YGCSS.StyleSheets=document.styleSheets[document.styleSheets.length-1];
      YGCSS.StyleSheetsLength = YGCSS.StyleSheets.cssRules.length;
    }
    YGCSS.StyleSheets.insertRule(rule,YGCSS.StyleSheetsLength++);
  },

  ColorStyles_tags:["~6", "~7", "~8", "~A", "~C", "~D","~F"],

  ColorStyles:{
  /* The numbers in each line are sorted in luminosity order :
      low/right border (greyish, darkest) (depth effect)
      buttons_selected
      button_unselected
      header_selected,  (could be same as above ?)
      header+footer unselected
      up-left border (light, unsaturated) (depth effect)
      text background (softest,lightest)
   */
  "default"    : "#666,#777,#888,#AAA,#CCC,#DDD,#FFF",
  "docStyle"   : "#233558,#344569,#45567A,#6678DC,#8896EE,#b0c5ff,#fafcff",
  "WinOK"      : "#355823,#456934,#567A45,#78DC66,#96EE88,#c5ffb0,#efffe0",
  "WinKO"      : "#583523,#694534,#7A5645,#DC7866,#EE9688,#ffc5b0,#ffefe0",
  "airy"       : "#d0dced,#dfecff,#dfecff,#d0dced,#d0dced,#d0dced,#dfecff",
  "ghost"      : "#DCDCDC,#00FF00,#00FF00,#C3C3C3,#A0A0A0,#808080,#DCDCDC",
/* early attempts : */
  "old_yellow" : "#662,#772,#883,#AA4,#CC5,#DD5,#FF6",
  "old_cyan"   : "#266,#277,#388,#4AA,#5CC,#5DD,#6FF",
  "old_blue"   : "#226,#227,#338,#44A,#55C,#55D,#66F",
  "old_red"    : "#622,#722,#833,#A44,#C55,#D55,#F66",
  "rouge2"     : "#ff3f0c,#ff673e,#ff7854,#ff8c6e,#ffa790,#ffd1c4,#ffe8e2",
  "vert3"      : "#0fdb00,#37db2b,#4ddb43,#61db58,#89db83,#a8dba4,#c6dbc4"
},

  default_style:"default",

  YgwmCssTemplate:[
 "{ border: 2px solid; position: absolute; border-color: ~D ~6 ~6 ~D",
 ">div.ygwm_header{background-color: ~C",
 ">div.ygwm_header_selected{background-color: ~A",
 ">div.ygwm_contents{background-color:~F",
 ">div.ygwm_footer{background-color: ~C",
 ">div.ygwm_footer > div.ygwm_cornerSW{border-color:~C ~C ~8 ~8",
 ">div.ygwm_footer > div.ygwm_cornerSE{border-color:~C ~8 ~8 ~C",
 ">div.ygwm_header          > div.ygwm_corner_close   {border-color:~C ~8 ~C ~8",
 ">div.ygwm_header_selected > div.ygwm_corner_close   {border-color:~A ~7 ~A ~7",
 ">div.ygwm_header          > div.ygwm_corner_minimize{border-color:~8 ~C ~C ~C",
 ">div.ygwm_header_selected > div.ygwm_corner_minimize{border-color:~7 ~A ~A ~A",
 ">div.ygwm_header          > div.ygwm_corner_maximize{border-color:~C ~C ~8 ~C",
 ">div.ygwm_header_selected > div.ygwm_corner_maximize{border-color:~A ~A ~7 ~A",
 ">div.ygwm_header          > div.roundButton7{border-color:~8",
 ">div.ygwm_header_selected > div.roundButton7{border-color:~7",
 ">div.ygwm_header            div.roundButton3{border-color:~C",
 ">div.ygwm_header_selected   div.roundButton3{border-color:~A"
],

  add_new_window_style: function(name){
    if ((!YGCSS.ColorStyles[name]) || (YGCSS.ColorStyles[name].loaded))
      return;  // continue if existing and not yet loaded

    var b="";
    var cols=YGCSS.ColorStyles[name].split(',');

    // regexp cache, done once and for good :
    if (!YGCSS.regexp) {
      YGCSS.regexp=[];
      for (var i in cols) // iterate from 0 to 6
        YGCSS.regexp[i]=new RegExp(YGCSS.ColorStyles_tags[i],"g");
    }

    for (var i=0; i<YGCSS.YgwmCssTemplate.length; i++) {
      b=YGCSS.YgwmCssTemplate[i];
      for (var j in cols)
        // could be better with a reverse lookup table
        if (b.indexOf(YGCSS.ColorStyles_tags[j]) != -1)
          b=b.replace(YGCSS.regexp[j],cols[j]);
      YGCSS.insertCssRule("div."+name+b+"}");
    }
  
    YGCSS.ColorStyles[name].loaded=true;  
  },

  // create rainbows out of a given color theme (7 3-tuples of increasing values)
  rotate_color: function(name,  a0, a1, a2,  b0, b1, b2,  c0, c1, c2,
                   d0, d1, d2,  e0, e1, e2,  f0, f1, f2,  g0, g1, g2 ){
    function n(name,  a0, a1, a2,  b0, b1, b2,  c0, c1, c2,
         d0, d1, d2,  e0, e1, e2,  f0, f1, f2,  g0, g1, g2 ){    
      if (!YGCSS.ColorStyles[name])
        YGCSS.ColorStyles[name]="#"+a0+a1+a2 +",#"+b0+b1+b2 +",#"+c0+c1+c2
         +",#"+d0+d1+d2 +",#"+e0+e1+e2 +",#"+f0+f1+f2 +",#"+g0+g1+g2;
    }
    n(name+"_bucy", a0, a1, a2,  b0, b1, b2,  c0, c1, c2,  d0, d1, d2,  e0, e1, e2,  f0, f1, f2,  g0, g1, g2);
    n(name+"_cyan", a0, a2, a2,  b0, b2, b2,  c0, c2, c2,  d0, d2, d2,  e0, e2, e2,  f0, f2, f2,  g0, g2, g2);
    n(name+"_cygr", a0, a2, a1,  b0, b2, b1,  c0, c2, c1,  d0, d2, d1,  e0, e2, e1,  f0, f2, f1,  g0, g2, g1);
    n(name+"_gren", a0, a2, a0,  b0, b2, b0,  c0, c2, c0,  d0, d2, d0,  e0, e2, e0,  f0, f2, f0,  g0, g2, g0);
    n(name+"_gryl", a1, a2, a0,  b1, b2, b0,  c1, c2, c0,  d1, d2, d0,  e1, e2, e0,  f1, f2, f0,  g1, g2, g0);
    n(name+"_yelo", a2, a2, a0,  b2, b2, b0,  c2, c2, c0,  d2, d2, d0,  e2, e2, e0,  f2, f2, f0,  g2, g2, g0);
    n(name+"_ylrd", a2, a1, a0,  b2, b1, b0,  c2, c1, c0,  d2, d1, d0,  e2, e1, e0,  f2, f1, f0,  g2, g1, g0);
    n(name+"_red" , a2, a0, a0,  b2, b0, b0,  c2, c0, c0,  d2, d0, d0,  e2, e0, e0,  f2, f0, f0,  g2, g0, g0);
    n(name+"_rdvl", a2, a0, a1,  b2, b0, b1,  c2, c0, c1,  d2, d0, d1,  e2, e0, e1,  f2, f0, f1,  g2, g0, g1);
    n(name+"_viol", a2, a0, a2,  b2, b0, b2,  c2, c0, c2,  d2, d0, d2,  e2, e0, e2,  f2, f0, f2,  g2, g0, g2);
    n(name+"_vibu", a1, a0, a2,  b1, b0, b2,  c1, c0, c2,  d1, d0, d2,  e1, e0, e2,  f1, f0, f2,  g1, g0, g2);
    n(name+"_blue", a0, a0, a2,  b0, b0, b2,  c0, c0, c2,  d0, d0, d2,  e0, e0, e2,  f0, f0, f2,  g0, g0, g2);
  },


  init: function() {
    YGCSS.rotate_color("sat",  "1e","38","53",  "00","48","91",  "34","6c","a0",
                  "08","70","d8",  "54","a1","ea",  "77","bd","ff",  "aa","d3","ff"); // from "bluecyan"

    YGCSS.rotate_color("doc", "23","35","58",  "34","45","69",  "45","56","7A",
             "66","78","DC",  "88","96","EE",  "b0","c5","ff",  "f4","f8","ff" );    // from "docStyle" 

    // preload all the styles...
    for (var i in YGCSS.ColorStyles)
      YGCSS.add_new_window_style(i);
  }

}

YGCSS.init();
